]> git.pld-linux.org Git - packages/mysql.git/blame - mysql.init
8.2.0
[packages/mysql.git] / mysql.init
CommitLineData
53a28f77 1#!/bin/sh
2#
7429b124 3# mysql A very fast and reliable SQL database engine
53a28f77 4#
7429b124 5# chkconfig: 2345 84 25
53a28f77 6#
350d9d8c 7# description: A very fast and reliable SQL database engine.
0b079830 8
53a28f77 9# Source function library
10. /etc/rc.d/init.d/functions
11
12# Get network config
13. /etc/sysconfig/network
14
aac2c31f
AM
15# Get service config
16if [ -f /etc/sysconfig/mysql ]; then
350d9d8c 17 . /etc/sysconfig/mysql
aac2c31f 18else
350d9d8c 19 nls "Error: %s not found" /etc/sysconfig/mysql
95b0575d 20 nls "%s can't be run." MySQL
350d9d8c
PG
21 exit 1
22fi
23
0146fae1 24if [ -n "$MYSQL_DB_CLUSTERS" ]; then
350d9d8c 25 nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
aac2c31f
AM
26fi
27
95b0575d 28if [ -f /etc/mysql/clusters.conf ]; then
ca39347b 29 MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
c0beb2ff 30 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
95b0575d
ER
31 nls "Warning: there are no configured clusters."
32 fi
0146fae1 33
95b0575d 34else
0146fae1 35 nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
c0beb2ff 36 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
95b0575d
ER
37 nls "Warning: there are no configured clusters."
38 nls "Using default cluster /var/lib/mysql (compatibility mode)"
39 MYSQL_DB_CLUSTERS=/var/lib/mysql
40 fi
aac2c31f
AM
41fi
42
95b0575d 43
ac28c610 44# Check that networking is up
8eb71226 45if is_yes "${NETWORKING}"; then
213fc2f2 46 if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
8eb71226 47 msg_network_down MySQL
48 exit 1
49 fi
50else
51 exit 0
e9ca44ab 52fi
53
874af6de 54sharedir=/usr/share/mysql
bf9eb59e 55
aac2c31f
AM
56action="$1"
57
58# any db cluster as command line argument?
521444a9 59if [ $# -gt 1 ]; then
350d9d8c
PG
60 shift
61 # perform action for specified clusters only
30b2aa9a
ER
62 for a in "$@"; do
63 # try auto resolving from /etc/mysql/clusters.conf
64 if [[ "$a" != /* ]]; then
65 m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66 if [ -z "$m" ]; then
67 echo >&2 "Cluster name '$a' did not match anything!"
68 exit 1
69 fi
70 if [ $(echo "$m" | wc -l) -gt 1 ]; then
71 echo >&2 "Cluster name '$a' ambiguous:" $m
72 exit 1
73 fi
74 a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75 fi
76 DB_CLUSTERS="$DB_CLUSTERS $a"
77 done
aac2c31f 78else
350d9d8c 79 DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
53a28f77 80fi
81
7c1478d5
ER
82# global error log, if mysqld.conf hasn't migrated to log-error style
83MYSQL_ERRLOG=/var/log/mysql/mysqld.log
c85758f0 84MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
aac2c31f
AM
85
86#
87# Useful functions.
88#
89
90#
91# check for mysql status
92#
93# arguments:
94# $1 - db cluster
c85758f0 95# $2 - start|stop
aac2c31f
AM
96#
97# sets variables:
c85758f0 98# MYSQL_STATUS = starting | running | not running | died
aac2c31f
AM
99# MYSQL_PID = pid of mysqld process
100#
101mysqlstatus() {
102 clusterdir="$1"
c85758f0
AM
103 mode="$2"
104
096a9b6f 105 mysqlgetconfig "$clusterdir" status
d405c4eb 106
350d9d8c
PG
107 MYSQL_STATUS="not running"
108 MYSQL_PID="unknown"
c85758f0
AM
109 MYSQL_PIDFILE_PID=""
110 MYSQL_GREP_PID=""
aac2c31f 111
c85758f0
AM
112 if [ -f "$MYSQL_PIDFILE" ]; then
113 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114 fi
115
116 if [ -n "$MYSQL_PIDFILE_PID" ]; then
117 MYSQL_PID=$MYSQL_PIDFILE_PID
118 if [ ! -d "/proc/$MYSQL_PID" ]; then
119 MYSQL_STATUS="died"
120 return
376ffa12 121 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
c85758f0
AM
122 MYSQL_STATUS="running"
123 return
124 fi
125 fi
6d3c5db5 126
c85758f0 127 if [ "$mode" = "start" ]; then
e8ea38a2 128 MYSQL_GREP_PID=$(grep -alE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
c85758f0
AM
129 if [ -n "$MYSQL_GREP_PID" ]; then
130 MYSQL_PID=$MYSQL_GREP_PID
0ca65658 131 if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
c85758f0
AM
132 if [ -f "$MYSQL_PIDFILE" ]; then
133 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134 fi
135 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136 MYSQL_PID=$MYSQL_PIDFILE_PID
137 MYSQL_STATUS="running"
138 return
139 else
140 MYSQL_STATUS="starting"
141 return
142 fi
143 fi
144 fi
6d3c5db5 145 fi
c85758f0
AM
146
147 # else default, "not running"
aac2c31f
AM
148}
149
150# get mysql configuration in variables
5e3157a9 151# MYSQL_CONFIG MYSQL_CLUSTER_DIR
e6d4b62c 152# MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
aac2c31f
AM
153#
154# arguments
155# $1 - db cluster
096a9b6f 156# $2 - status | other
aac2c31f
AM
157
158mysqlgetconfig() {
5e3157a9 159 local clusterdir="$1" config_file
096a9b6f 160 local mode="$2"
aac2c31f
AM
161
162 # emulate old behaviour if only one cluster specified
163 if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
0ca65658 164 MYSQL_RA_COMPAT=yes
aac2c31f 165 config_file=/etc/mysqld.conf
521444a9 166 else
5e3157a9 167 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
0ca65658 168 if [[ $config = /* ]]; then
d54e166d 169 config_file="$config"
fe2f6e01 170 elif [ -f "/etc/mysql/$config" ]; then
0ca65658 171 config_file="/etc/mysql/$config"
d54e166d
AM
172 else
173 config_file="$clusterdir/mysqld.conf"
174 fi
350d9d8c 175 fi
aac2c31f 176
0ca65658 177 MYSQL_CLUSTER_DIR="$clusterdir"
d405c4eb 178
521444a9 179 if [ -z "$config_file" ]; then
f9ad67df 180 nls "Error: Can't find config file for %s cluster" "$clusterdir"
096a9b6f
MM
181 if [ "$mode" = "status" ]; then
182 exit 3
183 else
184 exit 6
185 fi
f9ad67df 186 else
0ca65658 187 MYSQL_CONFIG="$config_file"
f9ad67df 188 fi
d405c4eb 189
aac2c31f
AM
190 if [ ! -f "$config_file" ]; then
191 nls "Error: config file %s not found" "$config_file"
350d9d8c 192 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
096a9b6f
MM
193 if [ "$mode" = "status" ]; then
194 exit 3
195 else
196 exit 6
197 fi
aac2c31f
AM
198 fi
199
b3be1198 200 # reset to initial state
e6d4b62c 201 MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
b3be1198
ER
202
203 eval `awk -F= '
ca39347b
ER
204 {
205 # undos
206 gsub(/\r$/, "");
207
208 # trim spaces
3dc69a76
ER
209 gsub(/^[\t ]+|[\t ]+$/, "", $1);
210 gsub(/^[\t ]+|[\t ]+$/, "", $2);
ca39347b
ER
211 }
212
b3be1198
ER
213 # skip comments and empty lines
214 /^[;#]|^ *$/ { next }
215
216 /^[ \t]*\[.*\][ \t]*$/ {
217 match($0, /\[.*\]/);
218 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
219 next;
823c13f7 220 }
e9ca44ab 221
b3be1198 222 section == "mysqld" {
3dc69a76 223 if ($1 == "datadir") {
b3be1198 224 printf("MYSQL_DATA_DIR=%s;", $2);
3dc69a76 225 } else if ($1 == "user") {
b3be1198 226 printf("MYSQL_USER=%s;", $2);
3dc69a76 227 } else if ($1 == "pid-file") {
b3be1198 228 printf("MYSQL_PIDFILE=%s;", $2);
3dc69a76 229 } else if ($1 == "socket") {
b3be1198 230 printf("MYSQL_SOCKET=%s;", $2);
3dc69a76 231 } else if ($1 == "port") {
b3be1198 232 printf("MYSQL_PORT=%s;", $2);
3dc69a76 233 } else if ($1 == "bind-address") {
b3be1198 234 printf("MYSQL_BIND_ADDRESS=%s;", $2);
3dc69a76 235 } else if ($1 == "skip-networking") {
9e39a858 236 printf("MYSQL_SKIP_NETWORKING=1;");
3dc69a76 237 } else if ($1 == "log-error") {
e6d4b62c 238 printf("MYSQL_LOG_ERROR=%s;", $2);
b3be1198
ER
239 }
240 }
241 ' $config_file`
e9ca44ab 242
e6d4b62c
ER
243 # error log not defined in config file. add one
244 if [ -z "$MYSQL_LOG_ERROR" ]; then
245 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
246 else
247 # unset, so mysqld would use value from config itself
248 unset MYSQL_LOG_ERROR
249 fi
250
d54e166d 251 if is_yes "$MYSQL_RA_COMPAT"; then
350d9d8c 252 MYSQL_DATA_DIR_SUB=""
8ee1d59c 253 else
350d9d8c 254 MYSQL_DATA_DIR_SUB="/mysqldb"
8ee1d59c 255 fi
d405c4eb 256
8ee1d59c 257 if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
350d9d8c
PG
258 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
259 nls " MySQL can't be run."
260 exit 6
8ee1d59c 261 fi
d405c4eb 262
8ee1d59c
AM
263 if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
264 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
265 nls " MySQL can't be run."
266 exit 6
267 fi
e9ca44ab 268
e6d4b62c 269 if [ -z "$MYSQL_USER" ]; then
350d9d8c
PG
270 echo "$(nls 'MySQL user not configured properly')"'!' >&2
271 nls "Edit %s and configure it." "$config_file" >&2
272 exit 6
860cd80c 273 fi
aac2c31f 274}
e9ca44ab 275
aac2c31f
AM
276# start mysql
277mysqlstart() {
5e3157a9 278 local clusterdir="$1"
aac2c31f
AM
279 mysqlgetconfig "$clusterdir"
280 if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
281 nls "MySQL cluster %s not initialized." "$clusterdir"
282 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
350d9d8c
PG
283 exit 6
284 fi
02e96f2e 285
5e3157a9 286 msg_starting "MySQL $clusterdir"; busy
aac2c31f 287 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
c85758f0 288 rm -f "$MYSQL_PIDFILE"
c4fbabf1 289
7c1478d5 290
c4fbabf1 291 TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
7429b124 292 /usr/bin/setsid /usr/sbin/mysqld \
c4fbabf1
ER
293 --defaults-file=$MYSQL_CONFIG \
294 --datadir=$MYSQL_DATA_DIR \
7c1478d5 295 --pid-file=$MYSQL_PIDFILE \
e6d4b62c 296 ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
7c1478d5 297 $MYSQL_OPTIONS &
c4fbabf1
ER
298 pid=$!
299
300 sleep 0.1
c85758f0
AM
301 mysqlstatus "$clusterdir" start
302 # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
303 if [ "$MYSQL_STATUS" = "starting" ]; then
c4fbabf1
ER
304 echo ""
305 show "Waiting for MySQL to start"
306 busy
307
308 # while the pid is running, mysql is starting up
309 # if the pidfile was created, it started up successfully
310 # if either case fails we break and report status
311 while true; do
312 [ -d /proc/$pid ] || break
c85758f0 313 [ -f "$MYSQL_PIDFILE" ] && break
c4fbabf1 314 sleep 0.2
c85758f0
AM
315 done
316 fi
317
318 mysqlstatus "$clusterdir" start
6d3c5db5 319 if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
aac2c31f 320 ok
47fd5a6a 321 elif [ "$MYSQL_STATUS" = "died" ]; then
350d9d8c 322 RETVAL=1
47fd5a6a 323 died
aac2c31f
AM
324 else
325 RETVAL=1
326 fail
53a28f77 327 fi
aac2c31f
AM
328}
329
330# stop mysql
331mysqlstop() {
5e3157a9 332 local clusterdir="$1"
c85758f0 333 mysqlstatus "$clusterdir" stop
aac2c31f
AM
334 msg_stopping "MySQL $clusterdir"
335 busy
95b0575d 336
95b0575d 337 # try graceful shutdown -- send shutdown command
566e62bb 338 # requires mysql_sysadmin user proper privs
465c110e 339 /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
c85758f0 340 mysqlstatus "$clusterdir" stop
95b0575d 341
c85758f0
AM
342 if [ "$MYSQL_PID" != "unknown" ]; then
343 kill -TERM "$MYSQL_PID" 2> /dev/null
344 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
345 [ -d "/proc/$MYSQL_PID" ] || break
346 sleep 0.1
347 done
348 fi
349
350 mysqlstatus "$clusterdir" stop
47fd5a6a 351 if [ "$MYSQL_STATUS" = "died" ]; then
350d9d8c 352 died
c85758f0 353 elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
aac2c31f 354 fail
b92e5cd1 355 else
aac2c31f 356 ok
b92e5cd1 357 fi
aac2c31f
AM
358}
359
70cdc654
ER
360# report slave status
361# uses MYSQL_SOCKET - path to mysql socket
362slave_status() {
13e5a8de
ER
363 if [ ! -x /usr/bin/mysql ]; then
364 echo >&2 "Slave status not available: 'mysql' program not installed."
365 return
366 fi
367
70cdc654 368 # see if slave status can be reported
ed3eec1b 369 local err=0 slave_status=$(mysql --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" -e 'show slave status\G')
70cdc654
ER
370 if [ -z "$slave_status" ]; then
371 # slave not setup
372 return
373 fi
374
288d6415 375 printf "Slave Status:\n"
70cdc654 376
7c5ef922 377 set -f
70cdc654
ER
378 eval $(echo "$slave_status" | awk -F': ' '/^ *[A-Za-z_]+:/{
379 k = tolower($1);
380 v = substr($0, length($1) + 3);
381 gsub(/\\/, "\\\\\\", v);
382 gsub(/"/, "\\\"", v);
383 gsub(/`/, "\\`", v);
384 gsub(/\$/, "\\$", v);
7c5ef922 385 gsub(/\$/, "\\$", v);
70cdc654
ER
386 printf("%s=\"%s\";\n", k, v);
387 }')
7c5ef922 388 set +f
70cdc654
ER
389
390 if [ "$slave_io_running" != "Yes" ]; then
391 printf "\tSlave IO not running\n"
392 err=1
393 fi
394 if [ "$slave_sql_running" != "Yes" ]; then
395 printf "\tSlave SQL not running\n"
396 err=1
397 fi
398
399 if [ "$err" = 1 -a "$last_errno" -gt 0 ]; then
7c5ef922 400 printf "\tERROR %s: %s\n" "$last_errno" "$last_error"
70cdc654
ER
401 fi
402
403 if [ "$master_log_file" != "$relay_master_log_file" ]; then
7c5ef922 404 printf "\tERROR logfile mismatch (%s)\n" "$relay_master_log_file"
70cdc654
ER
405 err=1
406 fi
407
408 if [ -z "$read_master_log_pos" -o -z "$exec_master_log_pos" ]; then
409 printf "\tERROR No info about master\n"
410 err=1
411 return
412 fi
413
414 diff=$(($read_master_log_pos - $exec_master_log_pos))
7c5ef922
ER
415 printf "\tread pos: %s (%s) (host: %s:%d)\n" "$read_master_log_pos" "$master_log_file" "$master_host" "$master_port"
416 printf "\texec pos: %s\n" "$exec_master_log_pos"
417 printf "\tdiff: %s\n" "$diff"
70cdc654
ER
418}
419
aac2c31f
AM
420#
421# check for running mysql instances; if any instance is running then
422# create subsys lock file
423#
424mysqlsubsys() {
350d9d8c
PG
425 # check for every defined db cluster in sysconfig file
426 for mysqldir in $DB_CLUSTERS; do
427 mysqlstatus "$mysqldir"
428 if [ "$MYSQL_STATUS" = "running" ]; then
429 touch /var/lock/subsys/mysql
430 return
431 fi
432 done
433 rm -f /var/lock/subsys/mysql
aac2c31f
AM
434}
435
436mysqlinit() {
5e3157a9 437 local clusterdir="$1"
8ee1d59c
AM
438
439 if [ -f /etc/mysqld.conf ]; then
350d9d8c
PG
440 nls "Running in \`no cluster compat' mode: can't initialize database."
441 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
442 exit 1
8ee1d59c
AM
443 fi
444
521444a9
AM
445 if [ -f "$clusterdir/mysqld.conf" ]; then
446 mysqlgetconfig "$clusterdir"
447 else
416b5906 448 MYSQL_USER="root"
521444a9
AM
449 MYSQL_CLUSTER_DIR="$clusterdir"
450 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
451 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
452 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
fe98cc4a
ER
453
454 # this $MYSQL_CONFIG will be created later
455 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
521444a9 456 fi
aac2c31f 457
092832b7 458 show "Initializing cluster %s" "$clusterdir"; started
aac2c31f 459
573e1dcc 460 # Check if not exist init database
e9ca44ab 461 if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
c70c8930 462 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
b92e5cd1 463 nls "before initializing database."
aac2c31f 464 nls "For now skipping cluster %s." "$clusterdir"
df1ac9e1 465 exit 6
e9ca44ab 466 fi
467
874af6de 468 show "Initializing MySQL database for $MYSQL_DATA_DIR"
e9ca44ab 469 busy
d405c4eb
JB
470 TMP=/tmp TMPDIR=/tmp
471
c4fbabf1 472 mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
f5d63301
AM
473 # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
474 chown root:root "$MYSQL_CLUSTER_DIR"
5f961775 475 chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
653cf157 476 chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
444f9f3c 477
bf9eb59e 478 if [ -f $sharedir/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
c0beb2ff
ER
479 sed -e "
480 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
481 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
482 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
483 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
bf9eb59e 484 " $sharedir/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
c0beb2ff
ER
485 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
486 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
444f9f3c 487 fi
cc4d3f78 488
b9c4f95d 489 ok=0
5ab9fb7b
JR
490 /usr/sbin/mysqld \
491 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
874af6de 492 --initialize \
5ab9fb7b
JR
493 --skip-grant-tables \
494 --datadir=$MYSQL_DATA_DIR \
495 --user=$MYSQL_USER \
496 --slave-load-tmpdir=$MYSQL_DATA_DIR \
497 --tmpdir=$MYSQL_DATA_DIR \
498 --log-error=$MYSQL_ERRLOG \
874af6de 499 && ok=1
4845ab08 500 [ -f $MYSQL_DATA_DIR/mysql/user.frm ] || ok=0
c4fbabf1 501
b9c4f95d 502 if [ "$ok" = 1 ]; then
5f961775
JR
503 ok
504 cat << END_OF_MSG
6a46c354 505
506PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
5f961775 507
874af6de
AM
508Start database:
509$ service mysql start
510
511and set passwords:
512
874af6de 513For 'root' user (ALL privileges, DB admin), paste command with new password:
416b5906
AM
514ALTER USER 'root'@'localhost' IDENTIFIED BY 'newpassword';
515FLUSH PRIVILEGES;
516
517For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
518CREATE USER 'mysql_sysadmin'@'localhost' IDENTIFIED BY 'sysnewpassword' PASSWORD EXPIRE NEVER;
519GRANT RELOAD, SHUTDOWN ON *.* TO 'mysql_sysadmin'@'localhost';
520FLUSH PRIVILEGES;
521
522
523Both into command:
524$ mysql -u root -p --ssl-mode=disabled -S $MYSQL_SOCKET
525
526NOTE 1:
527CURRENT TEMPORARY ROOT PASSWORD CAN BE FOUND IN LOG
528(grep for "A temporary password is generated" string):
529$MYSQL_ERRLOG
874af6de 530
6a46c354 531
416b5906
AM
532NOTE 2:
533mysql_sysadmin password should be placed to $MYSQL_CONFIG in
6a46c354 534mysqladmin section. See the manual for more instructions.
566e62bb 535(This user is used at logs rotation and server shutdown)
e9ca44ab 536
5f961775 537END_OF_MSG
5f961775
JR
538 else
539 fail
540 cat << END_OF_MSG
4ff46415
AM
541ERROR:
542ERROR:
874af6de 543ERROR: Installation FAILED!
4ff46415
AM
544ERROR:
545ERROR:
e9ca44ab 546
874af6de 547Examine the logs in $MYSQL_ERRLOG for more information. You can
b9c4f95d 548also try to start the mysqld daemon with:
e9ca44ab 549
550/usr/sbin/mysqld --skip-grant &
551
dc7a177f 552You can use the command line tool mysql to connect to the mysql
e9ca44ab 553database and look at the grant tables:
554
dc7a177f 555shell> mysql -u mysql mysql
e9ca44ab 556mysql> show tables
557
558Try 'mysqld --help' if you have problems with paths. Setting on
4581ca2d 559logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
e9ca44ab 560may be helpful. The latest information about MySQL is available on the
78b16243 561web at http://www.mysql.com/.
e9ca44ab 562
a3eb9e7b 563Please check PLD Linux ftp site for newer versions of this package.
e9ca44ab 564
565Please consult the MySQL manual section: 'Problems running
566mysql_install_db', and the manual section that describes problems on
c0beb2ff 567your OS. Another information source is the MySQL email archive.
e9ca44ab 568
569END_OF_MSG
5f961775 570 exit 1
aac2c31f 571 fi
80fc3cc1
ER
572
573 # if it's first server, register as default
574 if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
575 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
c0beb2ff 576 ln -s "$sock" /var/lib/mysql/mysql.sock
80fc3cc1 577 fi
722bcca2
ER
578 # same for config, move to /etc
579 if [ ! -e /etc/mysql/mysqld.conf ]; then
580 mv "$MYSQL_CLUSTER_DIR/mysqld.conf" /etc/mysql/mysqld.conf
581 fi
aac2c31f
AM
582}
583
584#
585# End of useful functions.
586#
587
323256af 588start() {
5e3157a9 589 local mysqldir
aac2c31f 590 for mysqldir in $DB_CLUSTERS; do
c85758f0 591 mysqlstatus "$mysqldir" start
aac2c31f
AM
592 if [ "$MYSQL_STATUS" = "running" ]; then
593 msg_already_running "MySQL $mysqldir"
594 else
595 mysqlstart "$mysqldir"
596 fi
597 done
598 mysqlsubsys
323256af
ER
599}
600
601stop() {
5e3157a9 602 local mysqldir
aac2c31f 603 for mysqldir in $DB_CLUSTERS; do
c85758f0 604 mysqlstatus "$mysqldir" stop
aac2c31f
AM
605 if [ "$MYSQL_STATUS" = "not running" ]; then
606 msg_not_running "MySQL $mysqldir"
607 else
608 mysqlstop "$mysqldir"
609 fi
610 done
611 mysqlsubsys
323256af
ER
612}
613
7429b124 614condrestart() {
5e3157a9 615 if [ ! -f /var/lock/subsys/mysql ]; then
7429b124
JB
616 msg_not_running "MySQL"
617 RETVAL=$1
5e3157a9 618 return
7429b124 619 fi
5e3157a9
ER
620
621 stop
622 start
7429b124
JB
623}
624
0d6ce890 625status() {
8b768513 626 local mysqldir addr port socket pid pids running datadir
0e94191b 627 RETVAL=3
aac2c31f
AM
628 for mysqldir in $DB_CLUSTERS; do
629 mysqlstatus "$mysqldir"
2bac5c2d 630 if [ "$MYSQL_STATUS" = "running" ]; then
0e94191b 631 RETVAL=0
b3be1198
ER
632 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
633 port=${MYSQL_PORT:-3306}
634 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
635 pid=$MYSQL_PID
9e39a858
ER
636 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
637 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
bb821a4c 638 nls "\tunix: %s\n" "$socket"
70cdc654
ER
639
640 MYSQL_SOCKET=$socket slave_status
641
b2bb6a82 642 pids="$pids/$MYSQL_PID/"
2bac5c2d
ER
643 progress "$MYSQL_STATUS"
644 else
27698ac1 645 show "MySQL cluster %s" "$mysqldir"
2bac5c2d
ER
646 progress "$MYSQL_STATUS" "$CFAIL"
647 fi
648 echo
aac2c31f 649 done
b2bb6a82
ER
650
651 for pid in $(/sbin/pidof mysqld); do
652 if [[ $pids != */$pid/* ]]; then
653 running="$running $pid"
654 fi
655 done
b7d0a657 656
a5595931 657 if [ $# = 1 -a "$running" ]; then
b2bb6a82
ER
658 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
659 # see if we can display their status
660 for pid in $running; do
b7d0a657 661 datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
b2bb6a82
ER
662 datadir=${datadir#--datadir=} # strip --datadir
663 mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
664 mysqlstatus "$mysqldir"
665 if [ "$MYSQL_STATUS" = "running" ]; then
b3be1198
ER
666 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
667 port=${MYSQL_PORT:-3306}
668 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
9e39a858
ER
669 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
670 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
bb821a4c 671 nls "\tunix: %s\n" "$socket"
70cdc654
ER
672
673 MYSQL_SOCKET=$socket slave_status
674
b2bb6a82
ER
675 progress "$MYSQL_STATUS"
676 else
677 show "MySQL cluster %s" "$mysqldir"
678 progress "$MYSQL_STATUS" "$CFAIL"
679 fi
680 echo
681 done
682 fi
0d6ce890
ER
683}
684
685RETVAL=0
686case "$action" in
687 start)
688 start
689 ;;
690 stop)
691 stop
692 ;;
693 restart)
694 stop
695 start
696 ;;
697 try-restart)
698 condrestart 0
699 ;;
700 force-reload)
701 condrestart 7
702 ;;
703 init)
704 for mysqldir in $DB_CLUSTERS; do
705 mysqlinit "$mysqldir"
706 done
707 exit $?
708 ;;
709 flush-logs)
710 for mysqldir in $DB_CLUSTERS; do
c0beb2ff 711 mysqlgetconfig "$mysqldir"
0d6ce890
ER
712 # just if mysqld is really running
713 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
714 /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
715 fi
716 done
717 ;;
718 status)
719 status
aac2c31f 720 ;;
53a28f77 721 *)
33cdd78d 722 msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
02e96f2e 723 exit 3
53a28f77 724esac
40c36bca 725
ee9b6a50 726exit $RETVAL
This page took 0.253705 seconds and 4 git commands to generate.